import datetime
import threadpool
import threading


def tpool(num_workers, callable_, args_list=None, show: bool = True, block: bool = True):
    args_list = list(args_list)
    finish = threading.Lock()
    finish.acquire()
    funcName = callable_.__name__

    def show_tips():
        begin = datetime.datetime.now()
        print(f'{funcName} 开始 {num_workers} 线程 {begin.strftime("%H:%M:%S")}')
        while not finish.acquire(timeout=3):
            print(f'{funcName} 还剩 {len(pool.workRequests)} 任务')
        end = datetime.datetime.now()
        print(f'{funcName} 完成 {end.strftime("%H:%M:%S")} 耗时 {str(end - begin).split(".")[0]}')

    def check():
        pool.wait()
        finish.release()

    pool = threadpool.ThreadPool(num_workers)
    show and threading.Thread(target=show_tips).start()
    if args_list:
        [pool.putRequest(req) for req in threadpool.makeRequests(callable_, args_list)]
    else:
        [pool.putRequest(threadpool.WorkRequest(callable_)) for _ in range(num_workers)]
    check() if block else threading.Thread(target=check).start()

    return True
